\ analyse av lengdeobs og xy-koo
\ 1.lesing linjevis til mellombels struktur

\ maxmin+-: l-oppsamlar
maxmin+-: #desimalarm \ antal innleste desimalar i x,y,l
maxmin+-: #desimalarg \ antal innleste desimalar i vinkel

\ henting frå kolonnar i mstruktur -------------------

: @dpl ( kolonnenr -- dpl )   \ desimalteiknplassering
	kolonne{ swap } 2@ ( n dpl ) nip ;
	
\ Henting frå mellombels struktur, f=0 når n er ugyldig (umålt),
\ utan desimalar for analyse, jfr @fix0
: @fix0f  ( kolonnenr -- f n )  koflag{ over } @ swap @fix0 ;

\ med desimalar, for tabellane, jfr @fix
: @fixf   ( kolonne -- f n )    koflag{ over } @ swap @fix ;
: @fixand ( kolonne -- n|0 )    @fixf and ;

\ koolinjer----------------------------------------------------------
2VARIABLE xymin          \ falsk origo

: analyserkoo   ( -- )
	1 #koolinjer +!
	\ x frå kolonne 1 og y frå kolonne 2
	1 @fix0 til x-oppsamlar  2 @fix0 til y-oppsamlar 
	3 @fix0f swap IF  til h-oppsamlar  3 @dpl til #desimalarm  ELSE  drop  THEN
	1 @dpl til #desimalarm   2 @dpl til #desimalarm ;

\ obslinjer------------------------------------------------------------------
logg: lS-oppsamlar
logg: hv-oppsamlar
logg: vv-oppsamlar
logg: i-oppsamlar   logg: s-oppsamlar
logg: dh-oppsamlar

\ innfilformat for obs-linjer:
\ kolonne 0 og 1 er pktnamn. Vidare er:
2 constant kolonneHV   \ hor vinkel
3 constant kolonneVV   \ vert. vinkel
4 constant kolonneLS   \ lengde
5 constant kolonnei    \ instrumenth
6 constant kolonnes    \ sikteh

variable #orienteringar  \ for o-element
create OriGmla  16 allot   variable OriGmlu \ adr og len

: NyOrientering?  ( -- f ) \ ny dersom stasjon er ulik stasjonen i linja over
	kostreng{ 0 } 2@  OriGmla OriGmlu @  COMPARE ;

: OriGmlOppdater ( -- )  kostreng{ 0 } 2@  dup OriGmlu !  OriGmla swap cmove ;

: analyserHV ( -- )
	kolonneHV dup @fix0f ( kolonnenr f n )
	swap IF  
		til hv-oppsamlar  @dpl til #desimalarg ( )
		NyOrientering? IF  1 #orienteringar +!  OriGmlOppdater  THEN
	ELSE
		( kolonnenr n ) 2drop
	THEN ;

: analyserVV ( -- )
	kolonneVV @fix0f  ( vv f ) IF  
		til vv-oppsamlar  kolonneVV @dpl til #desimalarg  
	THEN ;

: analyserLS ( -- )
	kolonneLS @fix0f AND ?dup IF  
		til ls-oppsamlar  kolonneLS @dpl til #desimalarm  
	THEN ;

: analyserVertikalt2 ( vv i s -- )
	2dup til s-oppsamlar   til i-oppsamlar
	kolonnei @dpl til #desimalarm  kolonnes @dpl til #desimalarm
	2drop ( deltah ) til dh-oppsamlar ;

: analyserVertikalt1 ( vv-- )
	dup til vv-oppsamlar  kolonneVV @dpl til #desimalarg  ( vv )
 	kolonnei @fix0f ( vv f i )  kolonnes @fix0f ( vv f i f s ) 
	rot swap 2swap and ( vv i s f ) IF  analyserVertikalt2  ELSE 2drop drop  THEN ;

: analyserVertikalt ( -- )
	kolonneVV @fix0f swap ( vv f ) IF  analyserVertikalt1  ELSE  drop  THEN ;
	
: analyserObs ( -- ) 1 #obslinjer +!  analyserHV  analyserLS  analyserVertikalt ;

\ -----------------------------------------------------------------------------------

: analyser ( -- )
	koo-linje? IF  analyserkoo  ELSE
	obs-linje? IF  analyserobs  ELSE
	cr ." Linje utan koo eller obs" THEN THEN ;

: .evtMinMax ( n1 n2 antal -- )
	IF SWAP ." , min max: " . .  ELSE  2drop  THEN ;

: sumanalysekoo
	x-oppsamlar    CR	SWAP ." Xmin Xmax: " . .
	y-oppsamlar    CR	SWAP ." Ymin Ymax: " . .
	h-oppsamlar    CR	dup . ."  pkt med kjent H " IF 
		swap ." Hmin Hmax: " . .  ELSE 2drop  THEN ;

: sumanalyseobs
	hv-oppsamlar   CR dup . ." stk hor.v " .evtMinMax
	vv-oppsamlar   CR dup . ." stk vert.v " .evtMinMax  
	ls-oppsamlar   CR dup . ." stk skrålengde " .evtMinMax  
	i-oppsamlar   CR dup . ." stk instrh. " .evtMinMax
	s-oppsamlar   CR dup . ." stk sikteh. " .evtMinMax
	dh-oppsamlar   CR dup . ." stk vv med i og s " .evtMinMax  
	cr #orienteringar ? ." stasjonar med orientering" ;

: sumanalyse
	#koolinjer @ IF  sumanalysekoo  THEN
	#obslinjer @ IF  
		sumanalyseobs
		#desimalarg  SWAP CR ." Desimalar vinklar min max: " .	. 
	THEN 
	#desimalarm  SWAP CR ." Desimalar lengder min max: " .	. ;

\ -----------------------------------------

: GranskLinje ( a u -- )
	1 #linjer +!
	DUP IF 
		datalinje?
		IF   1 #datalinjer +!  analyser  THEN
	ELSE
		2DROP   \ utan obs
	THEN ;
	
: 0linjetall ( -- )
	0 #linjer !   0 #datalinjer !   
	0 #koolinjer !   0 #obslinjer ! 
	0 #orienteringar !  0 OriGmlu ! ;

: LesLinjer ( -- #datalinjer )  \ 1.lesing
	\ testfil @ TO Input-File
	0linjetall
	for-each-read ( a u )       \ Les linjevis
		GranskLinje   repeat    \ alle linjer
	\ Close-Input               \ står open for 2.lesing ?
	CR	#koolinjer ? ." koolinjer leste"
	CR	#obslinjer ? ." obslinjer leste"
	CR	#linjer ? ." linjer leste"
	CR	#datalinjer @ DUP . ." datalinjer leste" ;

\ einingar i inn/ut: --------------------------------------------
\ vekt på lengdeobs------------------------------------
\ oppgitt for utstyret, mm og mm/km, forval
5 VALUE fastfeil   5 VALUE kmfeil

\ vekt på vinkelobs------------------------------------
\ hor- og vertikalvinklar
\ oppgitt for utstyret, cc, forval
5 VALUE fastfeilcc

VARIABLE presisjonm   \ antal desimalar i m i rekning
VARIABLE e/m          \ iu-einingar pr meter
VARIABLE presisjong   \ antal desimalar i gon i rekning
VARIABLE e/g          \ iu-einingar pr gon
VARIABLE cordicar/iu  \ cordicar pr iu-eining
\ vanlege verdiar:
636620 VALUE roi            \ cordicar pr radian
4000000 VALUE fullsirkeliu  \ iu-einingar i 400 gon

: einingar ( #desimalar.min -- e/m|e/g ) \ einingar pr meter|gon
	0 MAX   1 SWAP
	0 ?DO   10 *   LOOP ;

: rekneeiningm   \ minste antal desimalar i x,y,l avgjer
 	#desimalarm	 DROP ( minste )
	DUP presisjonm !
	DUP einingar e/m !   places  
	presisjonm @ CR ." Rekning med : " . ." desimalar i meter"
	CR ." Einingar pr meter: " e/m ? ;
	
: rekneeiningg   \ minste antal desimalar i vv avgjer
 	#desimalarg	 DROP ( minste )
	DUP presisjong !
	DUP einingar e/g !  \ places  
	CR ." Vinklar inn/ut med : " . ." desimalar i gon"
	CR ." Einingar pr gon: " e/g @ DUP .
	DUP 400 * TO fullsirkeliu
	cordicar/gon SWAP / DUP cordicar/iu ! 
	cordicar/radian SWAP / TO roi
	."  Fullsirkel: " fullsirkeliu .   
	CR ." Kordiske pr eining: " cordicar/iu ?
	CR ." Einingar pr radian:" roi . ;
	
: >cordicar ( v -- v )  cordicar/iu @ * ;

: P>R ( rv L-- dx dy ) SWAP >cordicar SWAP (P>R) ;
: R>P ( dx dy -- L retnv ) (R>P) cordicar/iu @ / ;

\ normaliser vinkel frå 0-399 til +-200 
 : normaliser0 ( vinkel -- vinkel ) \ i iu-eining
	DUP fullsirkeliu 2/  > IF  fullsirkeliu -  THEN ;

: ret+ ( n1 n2-- n3 ) \ sum og normaliser til 0-400
	+ DUP fullsirkeliu 1 - > IF  fullsirkeliu -  THEN ;

: ret- ( n1 n2-- n3 ) \ diff og normaliser til 0-400
	- DUP 0< IF  fullsirkeliu +  THEN ;

: SnuRv ( retn -- retn+200gon )
	fullsirkeliu 2/ ret+ ;

: horisontrer ( Lskrå vv -- Lhor ) >cordicar  (sin) */ ;

: cot ( v -- t n ) \ vinkel i iu - brøk 
	>cordicar 1000000 (P>R) ;
	
: tan ( v -- t n ) \ vinkel i iu - brøk
	>cordicar cot swap ;
	
: meterkomma   presisjonm @ places ;  \ bruk kommaplassering
: gonkomma     presisjong @ places ;  \ som forutsett ved fix

\ --------------------------------------------------
: origo ( -- )   \ falsk origo, avrunda, desimalar inkl
	x-oppsamlar  DROP  e/m @ * 
	y-oppsamlar  DROP  e/m @ * 
	xymin 2! ;

: vektgrunnlag ( -- ) \ antatt instrumentnøyaktigheit
	2000  e/m @ / 5 MAX TO fastfeil     \ aldri under 5 mm
	20000 e/g @ / 5 MAX TO fastfeilcc ; \ aldri under 5 cc
	\ 2000, 20000 og 5 er antatte tall
	
: analysesvar ( -- )
	sumanalyse   
	rekneeiningm rekneeiningg vektgrunnlag
	origo ;

: 1.lesing  ( -- #datalinjer )
	0
	Ansfilval  0= IF ." Ingen prosjektfil opna! " exit THEN
	LesLinjer  0= IF ." Ingen datalinjer! " exit THEN
	analysesvar #linjer @  ( 0 n )  \ med skriving til rapport
	NIP ( n ) ;


