\ koordinatforbetring
\ Løysing av likningane
\ Koordinatbetring blir gjentatt inntil godtnok

VARIABLE SumvvForrige

: .feilkvsum ( n -- )   \ for testing av skalering
	DUP    1 CELLS 8 *  DUP ROT SWAP	\ bits/celle
	CR 2 BASE !   .R   					\ vis fyllingsgrad
	CR DECIMAL    .R ;					\ rå, med skalering

: korreksjonar ( - )	        \ Ein omgang
   Normallikn1			\ rå normallikningar
   FinnSvar1 ;				\ kopier til A og løys

: .Endringar ( --  ) \ viser alle
	CR ." Elementforbetringar "
	etal2 @ 1 - 0 DO   X{ I } ?  LOOP ;
	
: MaxEndring ( -- max )
	0   etal2 @ 1 - 0 DO   X{ I } @   ABS MAX   LOOP ;
	
: ItResultat ( -- )
	sumpvvi @ .feilkvsum    \ oppskalert
	CR ." F.kv.sum " sumpvvi @
	-skaler -skaler .       \ nedskalert
	.Endringar ;

: Stabilt?   ( -- flag )  \ små korreksjonar
	MaxEndring 2 <   DUP IF  ." Elementforbetringar små nok. "   
	THEN ;

: Grovfeil?   ( -- flag )  \ 2 ulike avslutningsgrunna
	SumvvForrige @   sumpvvi @ <
	MaxEndring ( max )   20 >  AND
	DUP IF  CR  ." Store korr og f.kv.sum.-auke "  THEN
	;

: FKSAuke?   ( -- flag )  \ 2 ulike avslutningsgrunna
	SumvvForrige @   sumpvvi @ <   DUP IF  CR  ." Aukande f.kv.sum. "  THEN
	;
: FKSlik?   ( -- flag )  
	SumvvForrige @   sumpvvi @ =   DUP IF  CR  ." Stabil f.kv.sum. "  THEN
	;
	
: ForkastSiste
	." Pendling. Siste forkasta"
	SumvvForrige @   sumpvvi ! ;

\ -----------------------------------------------------------------------

: korriger1 ( pnr - ) \ korreksjonar i X -> XY{  
  DUP >R
  elementnr2 ( ex ey )
   X{ SWAP } @ ( ex dy )
   SWAP X{ SWAP } @ SWAP ( dx dy )   \ korreksjonar
	XY{ R@ } 2@  k+                  \ gamle koo + korr
	XY{ R> } 2! ;                    \ nye koo

: korrigerxy ( - )   \ alle nypkt
    AllePkt DO
       NYPNR{ I } @ IF I korriger1 THEN
    LOOP ;

: korriger1or ( ornr -- ) \ X{ inneheld or-korreksjon i trig-einingar )
	DUP ntal2 @ 2*  + ( elementnr ) X{ swap } @ ( ornr korreksjon )
	OE{ ROT } +! ;        \ OE{ inneheld or-vinklar i iu-einingar )

: korrigerOr
	#orienteringar @ 1 > IF
		#orienteringar @ 0 DO  I korriger1or  LOOP 
	ELSE
		0 korriger1or  \ unngå loop med 1 runde
	THEN ;

: korrigerxyo ( -- )
	korrigerxy   #orienteringar @  IF  korrigerOr  THEN ;

: Finrekn ( -- f )
	9 1 DO
		korreksjonar
		CR CR ." Iterasjon nr " I . ." :" ItResultat
		Grovfeil?    IF  CR ." Grovfeil"  0   UNLOOP EXIT   THEN
		FKSAuke?     IF  ForkastSiste    -1   UNLOOP EXIT   THEN
		FKSlik?      IF                  -1   UNLOOP EXIT   THEN
		Stabilt?     IF  korrigerxyo     -1   UNLOOP EXIT   THEN
		korrigerxyo
		sumpvvi @  SumvvForrige !
    LOOP -1 ;

: Iterert? ( -- f )
	CR BITS/CELL . ." Bits/celle"
    stort SumvvForrige !		\ set sumpvv stor
	Finrekn
	CR ;
	
: etalxy ( -- ) ntal2 @ 2*  #orienteringar @ +  etal ! ; \ antal ukjente

: Betra? ( -- f )  \ sann=vellukka
	etalxy NLiknplass normallikn1    
	etal @ +gauss   Iterert?  ( f )   ;

