\ vinkeleiningar heretter kalt cordicar

1000000 constant cordicar/gon \ vinkeleining her mikrogon
cordicar/gon 100 * constant kvartsirkel \  100 gon
kvartsirkel 4 * constant fullsirkel \ 400 gon
63661977 CONSTANT cordicar/radian

\ Trigonometric functions with CORDIC algorithm
\ copied with minor mods from Mecrisp Stellaris "common/sine.txt"

\ -----------------------------------------------------------------------------
\   Constant table necessary for all CORDIC computations
\ -----------------------------------------------------------------------------

create cordic-const  \ 26 stk   8 siffer ok
50000000 , \ kvartsirkel/2 i mikrogon
29516724 , 
15595826 ,
7916685 , 
3973705 , 
1988790 ,
994637 ,
497349 ,
248678 , 
124340 , 
62170 , 
31085 , 
15542 , 
7771 , 
3886 ,
1943 , 
971 , 
486 ,
243 , 
121 , 
61 ,
30 ,
15 ,
8 ,
4 ,
2 ,
1 ,
26 constant #const

607252935        \ wikipedia  60725293501
1000000000 2CONSTANT forkortingsfaktor ( brøk )
forkortingsfaktor drop CONSTANT forlengingsfaktor
\ -----------------------------------------------------------------------------
\   Small helpers for calculations
\ -----------------------------------------------------------------------------

cordic-const constant cordic-constants \ Allow stronger optimisations for the table address

\ : e^ka ( u -- x )  2 lshift cordic-constants  + @   ;   \ 32 bit
: e^ka ( u -- x ) 1 CELLS * cordic-constants  + @ ;   \ 32/64 bit
\ -----------------------------------------------------------------------------
\   Common building blocks for different CORDIC modes
\ -----------------------------------------------------------------------------

variable cordic-x
variable cordic-y
variable cordic-z

variable cordic-x'

: 2arshift ( n u -- d* ) 0 ?do 2/ loop  ;

: cordic-step-plus ( i -- ) >R
  cordic-x @ cordic-y @ R@ 2arshift + cordic-x' !
  cordic-y @ cordic-x @ R@ 2arshift - cordic-y  !
  cordic-z @             R> e^ka    + cordic-z  !

  cordic-x' @ cordic-x !
;

: cordic-step-minus ( i -- ) >R
  cordic-x @ cordic-y @ R@ 2arshift - cordic-x' !
  cordic-y @ cordic-x @ R@ 2arshift + cordic-y  !
  cordic-z @             R> e^ka    - cordic-z  !

  cordic-x' @ cordic-x !
;

\ -----------------------------------------------------------------------------
\   Angle --> Sine and Cosine
\ -----------------------------------------------------------------------------

: cordic-sincos ( f-angle -- f-cosine f-sine )
                ( Angle between -Pi/2 and +Pi/2 ! )

	forlengingsfaktor    cordic-x ! \ Scaling value to cancel gain of the algorithm
	0 cordic-y !
	cordic-z !

  #const 0 do
    cordic-z @ 0<
    if
      i cordic-step-plus
    else
      i cordic-step-minus
    then
  loop

  cordic-x @
  cordic-y @

;

kvartsirkel constant pi/2
kvartsirkel 2* constant halvsirkel

: cosinus ( f-angle -- f-cosine ) cordic-sincos drop  ;
: sinus ( f-angle -- f-sine ) cordic-sincos nip ;

\ -----------------------------------------------------------------------------
\   Range extension for Sine and Cosine
\ -----------------------------------------------------------------------------

: (cos) ( f-angle -- t n ) \ cos/ /cos
  abs 0
  pi/2 um/mod  3 and ( Quadrant f-angle )

  case
    0 of               cosinus        endof
    1 of negate pi/2 + cosinus negate endof
    2 of               cosinus negate endof
    3 of negate pi/2 + cosinus        endof
  endcase
	forkortingsfaktor nip ( brøk ) ;

: (sin) ( f-angle -- t n )
  dup >r \ Save sign
  abs 0
  pi/2  um/mod  3 and ( Quadrant f-angle )

  case
    0 of               sinus         endof
    1 of negate pi/2 + sinus         endof
    2 of               sinus  negate endof
    3 of negate pi/2 + sinus  negate endof
  endcase

  r> 0< if negate then
  forkortingsfaktor nip ( brøk )
;

\ -------R>P og P>R-----------------------------------

: (R>P) ( dx dy -- L retnv ) \ retn-vinkel i cordicar
	  over 0<  \ x < 0 ?
  if
    negate swap negate swap
    dup 0< if \ Now y < 0 ?
      halvsirkel         cordic-z !
    else
      halvsirkel negate cordic-z !
    then
  else
    0  cordic-z !
  then

	cordic-y !   cordic-x !

	#const 0 do
		cordic-y @ 0<
		if
			i cordic-step-minus
		else
			i cordic-step-plus
		then
	loop
	cordic-x @      forkortingsfaktor  */  cordic-z @
	dup 0< if fullsirkel + then ;

: forkort   forkortingsfaktor nip */ ;

: (P>R) ( rv L-- dx dy ) \ retn-vinkel i cordicar
	dup rot ( L L rv )
  ( abs ) 0          \ krev rv >= 0
  pi/2 um/mod  3 and ( Quadrant f-angle )
  case
    0 of                cordic-sincos                    endof
    1 of negate pi/2 +  cordic-sincos  swap negate swap  endof
    2 of                cordic-sincos  swap negate swap negate endof
    3 of negate pi/2 +  cordic-sincos       negate       endof
  endcase  ( L L cos sin )
	rot forkort rot rot forkort swap ( Lcos Lsin ) ;

