
: sigma ( meter -- mm )			\ mm pr lengdeobs
	kmfeil 1000 */ fastfeil + ;

\ utrekna i 'analyse' frå desimalantal i inndata
: .presisjonL   CR ." Presisjon lengder: " fastfeil . ." mm + " kmfeil . ." mm/km" ;
: .presisjonV   CR ." Presisjon vinklar: " fastfeilcc . ." cc" ;

\ vertikalvinklar
433 CONSTANT JR  \ 43,3 cc pr km, refraksjon og jordkrumning

5 CONSTANT vvtap \ 5 cc pr km*km

: sigmavv ( l2 -- cc )
	e/m @ dup * /      \ rekn om til meter*meter
	vvtap 1000000 */  fastfeilcc + ;

\ ---------------------------------------------------------------
logg: l2-oppsamlar     \ l*l, frå koo

dh-oppsamlar nip nip VALUE #vertikalobs

: lengstevv ( -- l2 n ) \ lengste vertv-sikt, kvadrert, l*l
	AlleSikt DO
		i HarVertikalobs? IF  \ har vertv, i og s
			i hypohypo til l2-oppsamlar
		THEN
	LOOP
	l2-oppsamlar ROT DROP ; \ n=0 betyr ingen vertikalobs
	
\ m for dårligste obs:
: MLengdMax ( -- mm ) ls-oppsamlar ROT 2DROP ( lmax )  sigma ;
: MRetnMax  ( -- cc ) fastfeilcc ;
: MVertiMax ( -- cc|0 ) lengstevv IF  sigmavv  ELSE  DROP 0  THEN ;

: .UtVekt   .presisjonL .presisjonV   
	CR ." Vektfordeling: 1cc tilsvarer 1mm"
	.sikt+v ;
\ ----------------------------------------------------------------
\ Vektskalering, for å få dårligste vekt =1
\ c= p*m*m der m er sigma for dårligste obs
\ og p=1=ønskt vekt på kvar komponent (obs),
\ men nøyaktighet aldri betre enn 1 rekneeining
\ sigmakomp*sqrt(3)=sigmavektor. c=skala

Variable vektskonstant \ vekt=vektskonstant/m*m  for å få vekter frå 1 og opp

: pskalering2 ( -- ) \ største m dannar vektskonstant m*m
	CR ." Minst nøyaktige observasjonar: (Retcc Vertvcc Lmm)"
	CR MRetnMax DUP .  MVertiMax  DUP . MLengdMax DUP . 
	MAX MAX  DUP *  vektskonstant ! ;   \ c i p=c/m*m
\ ---------------------------------------------------------------------
\ Påføring av nye vekter på obs:

: vektretn ( snr -- )
	HVvekt{ OVER } @ IF
		vektskonstant @ fastfeilcc  ( snr c m ) \ samme m på alle retn-obs
		DUP * /  HVvekt{ ROT } !
	ELSE DROP THEN ;

: vektlen ( snr -- )
	LSvekt{ OVER } @ IF
		LS{ OVER } @ e/m @ / vektskonstant @ ( snr l c )
		SWAP sigma ( snr c m )      \ m avheng av l
		DUP * /  LSvekt{ ROT } !    \ LSvekt{ !!!!!!!
	ELSE DROP THEN ;

: vektvvi ( snr -- )
	DUP HarVertikalobs? IF
		DUP hypohypo vektskonstant @ ( snr l c )
		SWAP  sigmavv ( snr c m )     \ m avheng av l
		DUP * / VVvekt{ ROT } !
	ELSE DROP THEN ;   \ sett vertikalobsvekt lik 0

: vektobs ( -- n ) 
	pskalering2   \ finn vektskonstant som gir minste vekt =1
	AlleSikt DO
		i vektretn i vektlen i vektvvi
	LOOP
	CR ." Vektskonstant " vektskonstant @ dup . 
	.UtVekt  ;
